/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.18
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */

"use strict";var objectMergeAdvanced=(()=>{var rt=Object.create;var I=Object.defineProperty,at=Object.defineProperties,ot=Object.getOwnPropertyDescriptor,ft=Object.getOwnPropertyDescriptors,nt=Object.getOwnPropertyNames,Y=Object.getOwnPropertySymbols,st=Object.getPrototypeOf,te=Object.prototype.hasOwnProperty,lt=Object.prototype.propertyIsEnumerable;var ee=(e,t,a)=>t in e?I(e,t,{enumerable:!0,configurable:!0,writable:!0,value:a}):e[t]=a,v=(e,t)=>{for(var a in t||(t={}))te.call(t,a)&&ee(e,a,t[a]);if(Y)for(var a of Y(t))lt.call(t,a)&&ee(e,a,t[a]);return e},j=(e,t)=>at(e,ft(t));var it=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),ut=(e,t)=>{for(var a in t)I(e,a,{get:t[a],enumerable:!0})},re=(e,t,a,r)=>{if(t&&typeof t=="object"||typeof t=="function")for(let s of nt(t))!te.call(e,s)&&s!==a&&I(e,s,{get:()=>t[s],enumerable:!(r=ot(t,s))||r.enumerable});return e};var ae=(e,t,a)=>(a=e!=null?rt(st(e)):{},re(t||!e||!e.__esModule?I(a,"default",{value:e,enumerable:!0}):a,e)),pt=e=>re(I({},"__esModule",{value:!0}),e);var Q=it((kf,qe)=>{"use strict";qe.exports=pa;function k(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function pa(e){if(e=e||{},e.circles)return ma(e);return e.proto?r:a;function t(s,f){for(var o=Object.keys(s),n=new Array(o.length),u=0;u<o.length;u++){var p=o[u],c=s[p];typeof c!="object"||c===null?n[p]=c:c instanceof Date?n[p]=new Date(c):ArrayBuffer.isView(c)?n[p]=k(c):n[p]=f(c)}return n}function a(s){if(typeof s!="object"||s===null)return s;if(s instanceof Date)return new Date(s);if(Array.isArray(s))return t(s,a);if(s instanceof Map)return new Map(t(Array.from(s),a));if(s instanceof Set)return new Set(t(Array.from(s),a));var f={};for(var o in s)if(Object.hasOwnProperty.call(s,o)!==!1){var n=s[o];typeof n!="object"||n===null?f[o]=n:n instanceof Date?f[o]=new Date(n):n instanceof Map?f[o]=new Map(t(Array.from(n),a)):n instanceof Set?f[o]=new Set(t(Array.from(n),a)):ArrayBuffer.isView(n)?f[o]=k(n):f[o]=a(n)}return f}function r(s){if(typeof s!="object"||s===null)return s;if(s instanceof Date)return new Date(s);if(Array.isArray(s))return t(s,r);if(s instanceof Map)return new Map(t(Array.from(s),r));if(s instanceof Set)return new Set(t(Array.from(s),r));var f={};for(var o in s){var n=s[o];typeof n!="object"||n===null?f[o]=n:n instanceof Date?f[o]=new Date(n):n instanceof Map?f[o]=new Map(t(Array.from(n),r)):n instanceof Set?f[o]=new Set(t(Array.from(n),r)):ArrayBuffer.isView(n)?f[o]=k(n):f[o]=r(n)}return f}}function ma(e){var t=[],a=[];return e.proto?f:s;function r(o,n){for(var u=Object.keys(o),p=new Array(u.length),c=0;c<u.length;c++){var m=u[c],l=o[m];if(typeof l!="object"||l===null)p[m]=l;else if(l instanceof Date)p[m]=new Date(l);else if(ArrayBuffer.isView(l))p[m]=k(l);else{var x=t.indexOf(l);x!==-1?p[m]=a[x]:p[m]=n(l)}}return p}function s(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return r(o,s);if(o instanceof Map)return new Map(r(Array.from(o),s));if(o instanceof Set)return new Set(r(Array.from(o),s));var n={};t.push(o),a.push(n);for(var u in o)if(Object.hasOwnProperty.call(o,u)!==!1){var p=o[u];if(typeof p!="object"||p===null)n[u]=p;else if(p instanceof Date)n[u]=new Date(p);else if(p instanceof Map)n[u]=new Map(r(Array.from(p),s));else if(p instanceof Set)n[u]=new Set(r(Array.from(p),s));else if(ArrayBuffer.isView(p))n[u]=k(p);else{var c=t.indexOf(p);c!==-1?n[u]=a[c]:n[u]=s(p)}}return t.pop(),a.pop(),n}function f(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return r(o,f);if(o instanceof Map)return new Map(r(Array.from(o),f));if(o instanceof Set)return new Set(r(Array.from(o),f));var n={};t.push(o),a.push(n);for(var u in o){var p=o[u];if(typeof p!="object"||p===null)n[u]=p;else if(p instanceof Date)n[u]=new Date(p);else if(p instanceof Map)n[u]=new Map(r(Array.from(p),f));else if(p instanceof Set)n[u]=new Set(r(Array.from(p),f));else if(ArrayBuffer.isView(p))n[u]=k(p);else{var c=t.indexOf(p);c!==-1?n[u]=a[c]:n[u]=f(p)}}return t.pop(),a.pop(),n}}});var Aa={};ut(Aa,{defaults:()=>tt,mergeAdvanced:()=>ba,version:()=>ga});var mt=typeof global=="object"&&global&&global.Object===Object&&global,C=mt;var dt=typeof self=="object"&&self&&self.Object===Object&&self,ct=C||dt||Function("return this")(),D=ct;var yt=D.Symbol,T=yt;var oe=Object.prototype,xt=oe.hasOwnProperty,gt=oe.toString,M=T?T.toStringTag:void 0;function ht(e){var t=xt.call(e,M),a=e[M];try{e[M]=void 0;var r=!0}catch(f){}var s=gt.call(e);return r&&(t?e[M]=a:delete e[M]),s}var fe=ht;var bt=Object.prototype,At=bt.toString;function vt(e){return At.call(e)}var ne=vt;var Et="[object Null]",St="[object Undefined]",se=T?T.toStringTag:void 0;function wt(e){return e==null?e===void 0?St:Et:se&&se in Object(e)?fe(e):ne(e)}var b=wt;function Dt(e){return e!=null&&typeof e=="object"}var A=Dt;var Tt="[object Symbol]";function $t(e){return typeof e=="symbol"||A(e)&&b(e)==Tt}var le=$t;function Rt(e,t){for(var a=-1,r=e==null?0:e.length,s=Array(r);++a<r;)s[a]=t(e[a],a,e);return s}var ie=Rt;var kt=Array.isArray,P=kt;var It=/\s/;function Mt(e){for(var t=e.length;t--&&It.test(e.charAt(t)););return t}var ue=Mt;var Vt=/^\s+/;function Bt(e){return e&&e.slice(0,ue(e)+1).replace(Vt,"")}var pe=Bt;function Nt(e){var t=typeof e;return e!=null&&(t=="object"||t=="function")}var V=Nt;var me=NaN,Ot=/^[-+]0x[0-9a-f]+$/i,jt=/^0b[01]+$/i,Ct=/^0o[0-7]+$/i,Pt=parseInt;function Ft(e){if(typeof e=="number")return e;if(le(e))return me;if(V(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=V(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=pe(e);var a=jt.test(e);return a||Ct.test(e)?Pt(e.slice(2),a?2:8):Ot.test(e)?me:+e}var de=Ft;var ce=1/0,Lt=17976931348623157e292;function Wt(e){if(!e)return e===0?e:0;if(e=de(e),e===ce||e===-ce){var t=e<0?-1:1;return t*Lt}return e===e?e:0}var ye=Wt;function Kt(e){var t=ye(e),a=t%1;return t===t?a?t-a:t:0}var xe=Kt;var Ut="[object AsyncFunction]",Jt="[object Function]",Gt="[object GeneratorFunction]",qt="[object Proxy]";function zt(e){if(!V(e))return!1;var t=b(e);return t==Jt||t==Gt||t==Ut||t==qt}var ge=zt;function _t(e,t,a,r){for(var s=e.length,f=a+(r?1:-1);r?f--:++f<s;)if(t(e[f],f,e))return f;return-1}var he=_t;function Qt(e){return e!==e}var be=Qt;function Ht(e,t,a){for(var r=a-1,s=e.length;++r<s;)if(e[r]===t)return r;return-1}var Ae=Ht;function Xt(e,t,a){return t===t?Ae(e,t,a):he(e,be,a)}var ve=Xt;var Zt=9007199254740991,Yt=/^(?:0|[1-9]\d*)$/;function er(e,t){var a=typeof e;return t=t==null?Zt:t,!!t&&(a=="number"||a!="symbol"&&Yt.test(e))&&e>-1&&e%1==0&&e<t}var Ee=er;var tr=9007199254740991;function rr(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=tr}var F=rr;function ar(e){return e!=null&&F(e.length)&&!ge(e)}var L=ar;var or=Object.prototype;function fr(e){var t=e&&e.constructor,a=typeof t=="function"&&t.prototype||or;return e===a}var Se=fr;function nr(e,t){for(var a=-1,r=Array(e);++a<e;)r[a]=t(a);return r}var we=nr;var sr="[object Arguments]";function lr(e){return A(e)&&b(e)==sr}var q=lr;var De=Object.prototype,ir=De.hasOwnProperty,ur=De.propertyIsEnumerable,pr=q(function(){return arguments}())?q:function(e){return A(e)&&ir.call(e,"callee")&&!ur.call(e,"callee")},Te=pr;function mr(){return!1}var $e=mr;var Ie=typeof exports=="object"&&exports&&!exports.nodeType&&exports,Re=Ie&&typeof module=="object"&&module&&!module.nodeType&&module,dr=Re&&Re.exports===Ie,ke=dr?D.Buffer:void 0,cr=ke?ke.isBuffer:void 0,yr=cr||$e,Me=yr;var xr="[object Arguments]",gr="[object Array]",hr="[object Boolean]",br="[object Date]",Ar="[object Error]",vr="[object Function]",Er="[object Map]",Sr="[object Number]",wr="[object Object]",Dr="[object RegExp]",Tr="[object Set]",$r="[object String]",Rr="[object WeakMap]",kr="[object ArrayBuffer]",Ir="[object DataView]",Mr="[object Float32Array]",Vr="[object Float64Array]",Br="[object Int8Array]",Nr="[object Int16Array]",Or="[object Int32Array]",jr="[object Uint8Array]",Cr="[object Uint8ClampedArray]",Pr="[object Uint16Array]",Fr="[object Uint32Array]",y={};y[Mr]=y[Vr]=y[Br]=y[Nr]=y[Or]=y[jr]=y[Cr]=y[Pr]=y[Fr]=!0;y[xr]=y[gr]=y[kr]=y[hr]=y[Ir]=y[br]=y[Ar]=y[vr]=y[Er]=y[Sr]=y[wr]=y[Dr]=y[Tr]=y[$r]=y[Rr]=!1;function Lr(e){return A(e)&&F(e.length)&&!!y[b(e)]}var Ve=Lr;function Wr(e){return function(t){return e(t)}}var W=Wr;var Be=typeof exports=="object"&&exports&&!exports.nodeType&&exports,B=Be&&typeof module=="object"&&module&&!module.nodeType&&module,Kr=B&&B.exports===Be,z=Kr&&C.process,Ur=function(){try{var e=B&&B.require&&B.require("util").types;return e||z&&z.binding&&z.binding("util")}catch(t){}}(),$=Ur;var Ne=$&&$.isTypedArray,Jr=Ne?W(Ne):Ve,Oe=Jr;var Gr=Object.prototype,qr=Gr.hasOwnProperty;function zr(e,t){var a=P(e),r=!a&&Te(e),s=!a&&!r&&Me(e),f=!a&&!r&&!s&&Oe(e),o=a||r||s||f,n=o?we(e.length,String):[],u=n.length;for(var p in e)(t||qr.call(e,p))&&!(o&&(p=="length"||s&&(p=="offset"||p=="parent")||f&&(p=="buffer"||p=="byteLength"||p=="byteOffset")||Ee(p,u)))&&n.push(p);return n}var je=zr;function _r(e,t){return function(a){return e(t(a))}}var Ce=_r;var Qr=Ce(Object.keys,Object),Pe=Qr;var Hr=Object.prototype,Xr=Hr.hasOwnProperty;function Zr(e){if(!Se(e))return Pe(e);var t=[];for(var a in Object(e))Xr.call(e,a)&&a!="constructor"&&t.push(a);return t}var Fe=Zr;function Yr(e){return L(e)?je(e):Fe(e)}var Le=Yr;var ea="[object String]";function ta(e){return typeof e=="string"||!P(e)&&A(e)&&b(e)==ea}var We=ta;function ra(e,t){return ie(t,function(a){return e[a]})}var Ke=ra;function aa(e){return e==null?[]:Ke(e,Le(e))}var Ue=aa;var oa=Math.max;function fa(e,t,a,r){e=L(e)?e:Ue(e),a=a&&!r?xe(a):0;var s=e.length;return a<0&&(a=oa(s+a,0)),We(e)?a<=s&&e.indexOf(t,a)>-1:!!s&&ve(e,t,a)>-1}var _=fa;var na="[object Date]";function sa(e){return A(e)&&b(e)==na}var Je=sa;var Ge=$&&$.isDate,la=Ge?W(Ge):Je,R=la;var ia=D.isFinite;function ua(e){return typeof e=="number"&&ia(e)}var K=ua;var ze=ae(Q(),1);var If=(0,ze.default)();function h(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function N(e){return typeof e=="string"}function _e(e){return Number.isFinite(e)}function U(e){return typeof e=="boolean"}function O(e){return e!=null}function Qe(e,t){return h(e)&&N(t)&&t in e}function He(e,t){return e.localeCompare(t)}function E(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:h(e)?!!Object.keys(e).length:typeof e=="number"}var et=ae(Q(),1);var Xe="14.0.18";function H(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var X=new Map,Ze=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(a=>{if(typeof a!="string"){if(typeof a>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof a}' in the array`)}return!0})},ca=(e,t)=>{t=v({caseSensitive:!1},t);let a=e+JSON.stringify(t);if(X.has(a))return X.get(a);let r=e[0]==="!";r&&(e=e.slice(1)),e=H(e).replace(/\\\*/g,"[\\s\\S]*");let s=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return s.negated=r,X.set(a,s),s},ya=(e,t,a,r)=>{if(e=Ze(e,"inputs"),t=Ze(t,"patterns"),t.length===0)return[];t=t.map(o=>ca(o,a));let{allPatterns:s}=a||{},f=[];for(let o of e){let n,u=[...t].fill(!1);for(let[p,c]of t.entries())if(c.test(o)&&(u[p]=!0,n=!c.negated,!n))break;if(!(n===!1||n===void 0&&t.some(p=>!p.negated)||s&&u.some((p,c)=>!p&&!t[c].negated))&&(f.push(o),r))break}return f};function J(e,t,a){return ya(e,t,a,!0).length>0}var xa={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function G(e,t,a){if(!e.length||!t.length)return!1;let r=v(v({},xa),a),s=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?s.some(f=>J(f,t,{caseSensitive:r.caseSensitive})):r.arrayVsArrayAllMustBeFound==="any"?t.some(f=>s.some(o=>J(o,f,{caseSensitive:r.caseSensitive}))):t.every(f=>s.some(o=>J(o,f,{caseSensitive:r.caseSensitive})))}var i=(0,et.default)(),ga=Xe,S=Array.isArray;function Ye(e){return!!e&&e.some(t=>typeof t=="string")}function ha(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(a=>Object.keys(t).includes(a))||Object.keys(t).every(a=>Object.keys(e).includes(a))}function g(e){return e===null?"null":R(e)?"date":h(e)?"object":S(e)?"array":typeof e}var tt={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function w(e,t,a,r){var c;let s;if(r.useNullAsExplicitFalse&&(t===null||a===null))return typeof r.cb=="function"?r.cb(t,a,null,{path:e.path,key:e.key,type:e.type}):null;let f=S(t)||h(t)?i(t):t,o=S(a)||h(a)?i(a):a,n;r.ignoreEverything?n=f:r.hardMergeEverything&&(n=o);let u=r.hardMergeEverything||r.ignoreEverything;if(S(f))if(E(f))if(S(o)&&E(o)){if(r.mergeArraysContainingStringsToBeEmpty&&(Ye(f)||Ye(o))){let l=u?n:[];return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:s,key:e.key,type:e.type}):l}if(r.hardArrayConcat){let l=u?n:f.concat(o);return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:s,key:e.key,type:e.type}):l}let m=[];for(let l=0,x=Math.max(f.length,o.length);l<x;l++)s=(c=e.path)!=null&&c.length?`${e.path}.${l}`:`${l}`,h(f[l])&&h(o[l])&&(r.mergeObjectsOnlyWhenKeysetMatches&&ha(f[l],o[l])||!r.mergeObjectsOnlyWhenKeysetMatches)?m.push(w({path:s,key:e.key,type:[g(f),g(o)]},f[l],o[l],r)):r.oneToManyArrayObjectMerge&&(f.length===1||o.length===1)?m.push(f.length===1?w({path:s,key:e.key,type:[g(f),g(o)]},f[0],o[l],r):w({path:s,key:e.key,type:[g(f),g(o)]},f[l],o[0],r)):r.concatInsteadOfMerging?(l<f.length&&m.push(f[l]),l<o.length&&m.push(o[l])):(l<f.length&&m.push(f[l]),l<o.length&&!_(f,o[l])&&m.push(o[l]));r.dedupeStringsInArrayValues&&m.every(l=>N(l))&&(m=[...new Set(m)].sort(He)),f=i(m)}else{let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:s,key:e.key,type:e.type}):m}else{if(E(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:s,key:e.key,type:e.type}):l}let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:s,key:e.key,type:e.type}):m}else if(h(f)){if(E(f)){if(S(o)){if(E(o)){let d=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),d,{path:s,key:e.key,type:e.type}):d}let x=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),x,{path:s,key:e.key,type:e.type}):x}if(h(o)){Object.keys(o).forEach(d=>{var Z;s=(Z=e.path)!=null&&Z.length?`${e.path}.${d}`:`${d}`,Qe(f,d)?G(d,r.ignoreKeys)?f[d]=w({path:s,key:d,type:[g(f),g(o)]},f[d],o[d],j(v({},r),{ignoreEverything:!0})):G(d,r.hardMergeKeys)?f[d]=w({path:s,key:d,type:[g(f),g(o)]},f[d],o[d],j(v({},r),{hardMergeEverything:!0})):G(d,r.hardArrayConcatKeys)?f[d]=w({path:s,key:d,type:[g(f),g(o)]},f[d],o[d],j(v({},r),{hardArrayConcat:!0})):f[d]=w({path:s,key:d,type:[g(f[d]),g(o[d])]},f[d],o[d],r):f[d]=o[d]});let x=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),x,{path:e.path,key:e.key,type:e.type}):f}let l=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}if(S(o)||h(o)||E(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(R(f)){if(K(+f)){if(R(o)){if(K(+o)){let d=u?n:f>o?f:o;return typeof r.cb=="function"?r.cb(i(t),i(a),d,{path:e.path,key:e.key,type:e.type}):d}let x=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),x,{path:e.path,key:e.key,type:e.type}):x}let l=u?n:o||f;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}if(R(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}let m=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(N(f)){if(E(f)){if((S(o)||h(o)||N(o))&&E(o)){let x=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),x,{path:e.path,key:e.key,type:e.type}):x}let l=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}if(O(o)&&!U(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(_e(f)){if(E(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(U(f)){if(U(o)){if(r.mergeBoolsUsingOrNotAnd){let x=u?n:f||o;return typeof r.cb=="function"?r.cb(i(t),i(a),x,{path:e.path,key:e.key,type:e.type}):x}let l=u?n:f&&o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}if(O(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(f===null){if(O(o)){let l=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),l,{path:e.path,key:e.key,type:e.type}):l}let m=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}else{let m=u?n:o;return typeof r.cb=="function"?r.cb(i(t),i(a),m,{path:e.path,key:e.key,type:e.type}):m}let p=u?n:f;return typeof r.cb=="function"?r.cb(i(t),i(a),p,{path:e.path,key:e.key,type:e.type}):p}function ba(e,t,a){var s,f;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");if(O(a)&&!h(a))throw new TypeError(`object-merge-advanced/mergeAdvanced(): [THROW_ID_02] The optional options object should be a plain object, currently it's ${JSON.stringify(a,null,4)} (type ${typeof a})`);let r=v(v({},tt),a);return typeof r.ignoreKeys=="string"&&(r.ignoreKeys=[r.ignoreKeys]),typeof r.hardMergeKeys=="string"&&(r.hardMergeKeys=[r.hardMergeKeys]),(s=r==null?void 0:r.hardMergeKeys)!=null&&s.includes("*")&&(r.hardMergeEverything=!0),(f=r==null?void 0:r.ignoreKeys)!=null&&f.includes("*")&&(r.ignoreEverything=!0),w({key:null,path:"",type:[g(e),g(t)]},e,t,r)}return pt(Aa);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.4
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/*! Bundled license information:

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
